var FreecellCards;
var FreecellRestartDeck;
var FreecellSpots;
var FreecellBoard;
var FreecellCell;
var FreecellFoundation;

function freecellClearBoard()
{
    Selected = null;
    SelectedOverlay.visible = false;
    GameOver.visible = false;
    YouWon.visible = false;
    if (FreecellSpots != null) {
        for (var i in FreecellSpots) {
            FreecellSpots[i].removeFromSuperview();
        }
    }
    if (FreecellCell != null) {
        for (var i in FreecellCell) {
            if (FreecellCell[i] != null) {
                FreecellCell[i].img.removeFromSuperview();
            }
        }
    }
    if (FreecellFoundation != null) {
        for (var i in FreecellFoundation) {
            if (FreecellFoundation[i] != null) {
                for (var j in FreecellFoundation[i]) {
                    FreecellFoundation[i][j].img.removeFromSuperview();
                }
            }
        }
    }
    if (FreecellBoard != null) {
        for (var i in FreecellBoard) {
            if (FreecellBoard[i] != null) {
                for (var j in FreecellBoard[i]) {
                    FreecellBoard[i][j].img.removeFromSuperview();
                }
            }
        }
    }
    FreecellRestartDeck = null;
    FreecellSpots = null;
    FreecellCell = null;
    FreecellFoundation = null;
    FreecellBoard = null;
}

function freecellNewBoard(d)
{
    freecellClearBoard();
    FreecellSpots = [];
    for (var i = 0; i < 4; i++) {
        var b = new Image;
        b.src = "Resources/selected.png";
        b.hOffset = 10 + i * 35;
        b.vOffset = 10;
        b.opacity = 128;
        b.window = Main;
        b.onMouseDown = "freecellDoCellEmptyClick("+i+")";
        b.zOrder = 1;
        FreecellSpots.push(b);
    }
    for (var i = 0; i < 4; i++) {
        var b = new Image;
        b.src = "Resources/selected.png";
        b.hOffset = 185 + i * 35;
        b.vOffset = 10;
        b.opacity = 128;
        b.window = Main;
        b.onMouseDown = "freecellDoFoundationClick("+i+")";
        b.zOrder = 1;
        FreecellSpots.push(b);
    }
    for (var i = 0; i < 8; i++) {
        var b = new Image;
        b.src = "Resources/selected.png";
        b.hOffset = 10 + i * 40;
        b.vOffset = 60;
        b.opacity = 128;
        b.window = Main;
        b.onMouseDown = "freecellDoBoardClick("+i+")";
        b.zOrder = 1;
        FreecellSpots.push(b);
    }
    FreecellCell = Array(4);
    FreecellFoundation = [Array(), Array(), Array(), Array()];
    FreecellBoard = [Array(), Array(), Array(), Array(), Array(), Array(), Array(), Array()];
    var deck;
    if (d) {
        deck = deckCopy(d);
    } else {
        deck = deckShuffle();
    }
    FreecellRestartDeck = deckCopy(deck);
    FreecellCards = [];
    while (deck.length > 0) {
        for (var i = 0; i < 8; i++) {
            if (deck.length > 0) {
                var c = deck.pop();
                c.img = new Image;
                c.img.src = c.src;
                c.img.hOffset = 10 + i * 40;
                c.img.vOffset = 60 + FreecellBoard[i].length * 13;
                c.img.window = Main;
                c.img.onMouseDown = "freecellDoBoardClick("+i+")";
                c.img.zOrder = 2 + FreecellBoard[i].length;
                var mi = new MenuItem;
                mi.title = "Show card ("+RankStr[c.rank]+SuitStr[c.suit]+")";
                mi.onSelect = "show(FreecellCards["+FreecellCards.length+"].img)";
                c.img.contextMenuItems = [mi];
                FreecellBoard[i].push(c);
                FreecellCards.push(c);
                if (doAnimate()) {
                    updateNow();
                }
            }
        }
    }
}

function freecellCheckWin()
{
    for (var i = 0; i < 4; i++) {
        if (FreecellFoundation[i].length < 13) {
            return false;
        }
    }
    return true;
}

function freecellCanPlace(c)
{
    for (var i = 0; i < 8; i++) {
        if (FreecellBoard[i].length == 0) {
            return true;
        }
        var d = FreecellBoard[i][FreecellBoard[i].length-1];
        if (d.rank == c.rank + 1 && d.color != c.color) {
            return true;
        }
    }
    for (var i = 0; i < 4; i++) {
        if ((FreecellFoundation[i].length == 0 && c.rank == 1)
         || (FreecellFoundation[i].length > 0 && c.suit == FreecellFoundation[i][FreecellFoundation[i].length-1].suit && c.rank == FreecellFoundation[i][FreecellFoundation[i].length-1].rank + 1)) {
            return true;
        }
    }
    return false;
}

function freecellCheckLose()
{
    for (var i = 0; i < 4; i++) {
        if (FreecellCell[i] == null) {
            return false;
        }
        if (freecellCanPlace(FreecellCell[i])) {
            return false;
        }
    }
    for (var i = 0; i < 8; i++) {
        if (FreecellBoard[i].length == 0) {
            return false;
        }
        if (freecellCanPlace(FreecellBoard[i][FreecellBoard[i].length-1])) {
            return false;
        }
    }
    return true;
}

function freecellCheckEndGame()
{
    if (freecellCheckWin()) {
        YouWon.visible = true;
    } else if (freecellCheckLose()) {
        GameOver.visible = true;
    }
}

function freecellTidyUp(c)
{
    for (var i = 0; i < 4; i++) {
        if ((FreecellFoundation[i].length == 0 && c.rank == 1)
         || (FreecellFoundation[i].length > 0 && c.suit == FreecellFoundation[i][FreecellFoundation[i].length-1].suit && c.rank == FreecellFoundation[i][FreecellFoundation[i].length-1].rank + 1)) {
            animateMove(c.img, 185 + i * 35, 10, 1);
            c.img.zOrder = 2 + FreecellFoundation[i].length;
            c.img.onMouseDown = "freecellDoFoundationClick("+i+")";
            FreecellFoundation[i].push(c);
            return true;
        }
    }
    return false;
}

function freecellTidy()
{
    do {
        var any = false;
        var lowest = 13;
        for (var i = 0; i < 4; i++) {
            if (FreecellFoundation[i].length == 0) {
                lowest = 0;
                break;
            }
            if (FreecellFoundation[i][FreecellFoundation[i].length-1].rank < lowest) {
                lowest = FreecellFoundation[i][FreecellFoundation[i].length-1].rank;
            }
        }
        for (var i = 0; i < 4; i++) {
            if (FreecellCell[i] != null && FreecellCell[i].rank <= lowest+2 && freecellTidyUp(FreecellCell[i])) {
                FreecellCell[i] = null;
                any = true;
            }
        }
        for (var i = 0; i < 8; i++) {
            if (FreecellBoard[i].length > 0 && FreecellBoard[i][FreecellBoard[i].length-1].rank <= lowest+2 && freecellTidyUp(FreecellBoard[i][FreecellBoard[i].length-1])) {
                FreecellBoard[i].pop();
                any = true;
            }
        }
    } while (any);
    freecellCheckEndGame();
}

function freecellDoCellEmptyClick(i)
{
    Undo.push("freecellDoCellEmptyClick("+i+")");
    if (Selected != null) {
        SelectedOverlay.visible = false;
        var c = eval(Selected.remove);
        animateMove(c.img, 10 + i * 35, 10, 1);
        c.img.onMouseDown = "freecellDoCellClick("+i+")";
        c.img.zOrder = 2;
        FreecellCell[i] = c;
        freecellTidy();
        Selected = null;
    } else {
        Undo.pop();
    }
}

function freecellCellRemove(i)
{
    var r = FreecellCell[i];
    FreecellCell[i] = null;
    return r;
}

function freecellDoCellClick(i)
{
    Undo.push("freecellDoCellClick("+i+")");
    if (Selected == null) {
        Undo[Undo.length-1] += " //select";
        var c = FreecellCell[i];
        Selected = c;
        Selected.remove = "freecellCellRemove("+i+")";
        SelectedOverlay.hOffset = c.img.hOffset;
        SelectedOverlay.vOffset = c.img.vOffset;
        SelectedOverlay.visible = true;
    } else if (Selected == FreecellCell[i]) {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    } else {
        Undo.pop();
    }
}

function freecellDoFoundationClick(i)
{
    Undo.push("freecellDoFoundationClick("+i+")");
    if (Selected != null) {
        if ((FreecellFoundation[i].length == 0 && Selected.rank == 1)
         || (FreecellFoundation[i].length > 0 && Selected.suit == FreecellFoundation[i][FreecellFoundation[i].length-1].suit && Selected.rank == FreecellFoundation[i][FreecellFoundation[i].length-1].rank + 1)) {
            SelectedOverlay.visible = false;
            var c = eval(Selected.remove);
            animateMove(c.img, 185 + i * 35, 10, 1);
            c.img.zOrder = 2 + FreecellFoundation[i].length;
            c.img.onMouseDown = "freecellDoFoundationClick("+i+")";
            FreecellFoundation[i].push(c);
            freecellTidy();
            Selected = null;
        } else {
            Undo[Undo.length-1] += " //select";
            Selected = null;
            SelectedOverlay.visible = false;
        }
    } else {
        Undo.pop();
    }
}

function freecellFreeCells()
{
    var n = 0;
    for (var i = 0; i < 4; i++) {
        if (FreecellCell[i] == null) {
            n++;
        }
    }
    return n;
}

function freecellMoveStack(s, j, i)
{
    if (j >= 0 && FreecellBoard[s].length - j - 1 <= freecellFreeCells()) {
        SelectedOverlay.visible = false;
        var r = [];
        for (var k = FreecellBoard[s].length - 1; k > j; k--) {
            var f = 0;
            while (f < 4 && FreecellCell[f] != null) {
                f++;
            }
            if (f < 4) {
                var c = FreecellBoard[s].pop();
                animateMove(c.img, 10 + f * 35, 10, 1);
                c.img.onMouseDown = "freecellDoCellClick("+f+")";
                c.img.zOrder = 2;
                FreecellCell[f] = c;
                r.push(f);
            } else {
                print("no space left in move stack");
                return;
            }
        }
        var c = FreecellBoard[s].pop();
        animateMove(c.img, 10 + i * 40, 60 + FreecellBoard[i].length * 13, 1);
        c.img.zOrder = 2 + FreecellBoard[i].length;
        c.img.onMouseDown = "freecellDoBoardClick("+i+")";
        FreecellBoard[i].push(c);
        while (r.length > 0) {
            var f = r.pop();
            var c = FreecellCell[f];
            animateMove(c.img, 10 + i * 40, 60 + FreecellBoard[i].length * 13, 1);
            c.img.zOrder = 2 + FreecellBoard[i].length;
            c.img.onMouseDown = "freecellDoBoardClick("+i+")";
            FreecellBoard[i].push(c);
            FreecellCell[f] = null;
        }
        freecellTidy();
        Selected = null;
    } else {
        Undo.pop();
    }
}

function freecellDoBoardClick(i)
{
    Undo.push("freecellDoBoardClick("+i+")");
    if (Selected == null) {
        if (FreecellBoard[i].length > 0) {
            Undo[Undo.length-1] += " //select";
            var c = FreecellBoard[i][FreecellBoard[i].length-1];
            Selected = c;
            Selected.remove = "FreecellBoard["+i+"].pop()";
            SelectedOverlay.hOffset = c.img.hOffset;
            SelectedOverlay.vOffset = c.img.vOffset;
            SelectedOverlay.visible = true;
        } else {
            Undo.pop();
        }
    } else if (FreecellBoard[i].length == 0) {
        var s = -1;
        for (var j = 0; j < 8; j++) {
            for (var k = 0; k < FreecellBoard[j].length; k++) {
                if (FreecellBoard[j][k] == Selected) {
                    s = j;
                }
            }
        }
        if (s >= 0) {
            var free = freecellFreeCells();
            var j = FreecellBoard[s].length-1;
            while (j > 0) {
                if (FreecellBoard[s][j-1].rank != FreecellBoard[s][j].rank+1 || FreecellBoard[s][j-1].color == FreecellBoard[s][j].color) {
                    break;
                }
                if (FreecellBoard[s].length - j - 1 == free) {
                    break;
                }
                j--;
            }
            freecellMoveStack(s, j, i);
        } else {
            SelectedOverlay.visible = false;
            var c = eval(Selected.remove);
            animateMove(c.img, 10 + i * 40, 60, 1);
            c.img.zOrder = 2;
            c.img.onMouseDown = "freecellDoBoardClick("+i+")";
            FreecellBoard[i].push(c);
            Selected = null;
            freecellTidy();
        }
    } else if (FreecellBoard[i][FreecellBoard[i].length-1] == Selected) {
        SelectedOverlay.visible = false;
        var i = 0;
        while (i < 4 && FreecellCell[i] != null) {
            i++;
        }
        if (i < 4) {
            var c = eval(Selected.remove);
            animateMove(c.img, 10 + i * 35, 10, 1);
            c.img.onMouseDown = "freecellDoCellClick("+i+")";
            c.img.zOrder = 2;
            FreecellCell[i] = c;
            freecellTidy();
        } else {
            Undo[Undo.length-1] += " //select";
        }
        Selected = null;
    } else {
        var d = FreecellBoard[i][FreecellBoard[i].length-1];
        if (d.rank == Selected.rank + 1 && d.color != Selected.color) {
            SelectedOverlay.visible = false;
            var c = eval(Selected.remove);
            animateMove(c.img, 10 + i * 40, 60 + FreecellBoard[i].length * 13, 1);
            c.img.zOrder = 2 + FreecellBoard[i].length;
            c.img.onMouseDown = "freecellDoBoardClick("+i+")";
            FreecellBoard[i].push(c);
            freecellTidy();
            Selected = null;
        } else {
            var s = -1;
            for (var j = 0; j < 8; j++) {
                for (var k = 0; k < FreecellBoard[j].length; k++) {
                    if (FreecellBoard[j][k] == Selected) {
                        s = j;
                    }
                }
            }
            if (s >= 0) {
                var j = FreecellBoard[s].length-1;
                while (--j >= 0) {
                    if (FreecellBoard[s][j].rank != FreecellBoard[s][j+1].rank+1 || FreecellBoard[s][j].color == FreecellBoard[s][j+1].color) {
                        j = -1;
                        break;
                    }
                    if (d.rank == FreecellBoard[s][j].rank + 1 && d.color != FreecellBoard[s][j].color) {
                        break;
                    }
                }
                freecellMoveStack(s, j, i);
            } else {
                Undo.pop();
            }
        }
    }
}

function freecellGetName()
{
    return "Freecell";
}

function freecellDoNew()
{
    freecellNewBoard();
}

function freecellDoRestart()
{
    if (FreecellRestartDeck != null) {
        freecellNewBoard(FreecellRestartDeck);
    }
}

function freecellDoHelp()
{
    var pairs = [];
    for (var i = 0; i < 4; i++) {
        if (FreecellCell[i] != null) {
            for (var j = 0; j < 8; j++) {
                if (FreecellBoard[j].length == 0) {
                    pairs.push([FreecellCell[i]]);
                } else if (FreecellCell[i].rank+1 == FreecellBoard[j][FreecellBoard[j].length-1].rank && FreecellCell[i].color != FreecellBoard[j][FreecellBoard[j].length-1].color) {
                    pairs.push([FreecellCell[i], FreecellBoard[j][FreecellBoard[j].length-1]]);
                }
            }
        }
    }
    if (pairs.length == 0) {
        for (var i = 0; i < 8; i++) {
            if (FreecellBoard[i].length > 0) {
                var c = FreecellBoard[i][FreecellBoard[i].length-1];
                for (var j = 0; j < 8; j++) {
                    if (FreecellBoard[j].length == 0) {
                        pairs.push([c]);
                    } else if (c.rank == FreecellBoard[j][FreecellBoard[j].length-1].rank+1 && c.color != FreecellBoard[j][FreecellBoard[j].length-1].color) {
                        pairs.push([c, FreecellBoard[j][FreecellBoard[j].length-1]]);
                    }
                }
            }
        }
    }
    if (pairs.length == 0) {
        if (FreecellCell[0] == null || FreecellCell[1] == null || FreecellCell[2] == null || FreecellCell[3] == null) {
            for (var i = 0; i < 8; i++) {
                if (FreecellBoard[i].length > 0) {
                    pairs.push([FreecellBoard[i][FreecellBoard[i].length-1]]);
                }
            }
        }
    }
    if (pairs.length > 0) {
        var p = pairs[random(0, pairs.length)];
        var a = [];
        for (var i = 0; i < p.length; i++) {
            a.push([p[i].img.hOffset, p[i].img.vOffset]);
        }
        flash(a);
    }
}

function freecellInfo()
{
    return "Freecell\n\n"+
        "Goal: Move all cards to the foundation (top right).\n\n"+
        "Play: Cards may be placed on top of another card of one higher rank and opposite colour. Any card may be placed in an empty spot on the board. Cards may be moved to the foundation in rank order, aces first, matching suit. The cells in the top left may hold one card at a time.";
}
