var GolfRestartDeck;
var GolfDeck;
var GolfBoard;
var GolfStack;
var GolfLabels;
var GolfLabelGame;
var GolfLabelScore;
var GolfLabelPar;
var GolfThisScore = 0;
var GolfScore = 0;
var GolfGames = 0;

function golfUpdateScore()
{
    GolfLabelGame.data = GolfGames;
    GolfLabelScore.data = GolfScore + GolfThisScore;
    if (GolfThisScore > 0) {
        GolfLabelPar.data = 5 * GolfGames;
    } else {
        GolfLabelPar.data = 5 * (GolfGames-1);
    }
}

function golfClearBoard(b)
{
    Selected = null;
    SelectedOverlay.visible = false;
    GameOver.visible = false;
    YouWon.visible = false;
    if (GolfLabels != null) {
        for (var i in GolfLabels) {
            GolfLabels[i].removeFromSuperview();
        }
    }
    if (GolfDeck != null) {
        for (var i in GolfDeck) {
            GolfDeck[i].img.removeFromSuperview();
        }
    }
    if (GolfBoard != null) {
        for (var i in GolfBoard) {
            for (var j in GolfBoard[i]) {
                GolfBoard[i][j].img.removeFromSuperview();
            }
        }
    }
    if (GolfStack != null) {
        for (var i in GolfStack) {
            GolfStack[i].img.removeFromSuperview();
        }
    }
    GolfRestartDeck = null;
    GolfDeck = null;
    GolfBoard = null;
    GolfStack = null;
    GolfLabels = null;
}

function golfNewBoard(d)
{
    golfClearBoard();
    GolfLabels = [];
    GolfLabels[0] = new Text(Main);
    GolfLabels[0].color = "#ffffff";
    GolfLabels[0].hAlign = "right";
    GolfLabels[0].hOffset = 60;
    GolfLabels[0].vOffset = 200;
    GolfLabels[0].data = "Game:";
    GolfLabels[0].size = 16;
    GolfLabels[1] = new Text(Main);
    GolfLabels[1].color = "#ffffff";
    GolfLabels[1].hAlign = "left";
    GolfLabels[1].hOffset = 65;
    GolfLabels[1].vOffset = 200;
    GolfLabels[1].size = 16;
    GolfLabelGame = GolfLabels[1];
    GolfLabels[2] = new Text(Main);
    GolfLabels[2].color = "#ffffff";
    GolfLabels[2].hAlign = "right";
    GolfLabels[2].hOffset = 60;
    GolfLabels[2].vOffset = 220;
    GolfLabels[2].data = "Score:";
    GolfLabels[2].size = 16;
    GolfLabels[3] = new Text(Main);
    GolfLabels[3].color = "#ffffff";
    GolfLabels[3].hAlign = "left";
    GolfLabels[3].hOffset = 65;
    GolfLabels[3].vOffset = 220;
    GolfLabels[3].size = 16;
    GolfLabelScore = GolfLabels[3];
    GolfLabels[4] = new Text(Main);
    GolfLabels[4].color = "#ffffff";
    GolfLabels[4].hAlign = "right";
    GolfLabels[4].hOffset = 60;
    GolfLabels[4].vOffset = 240;
    GolfLabels[4].data = "Par:";
    GolfLabels[4].size = 16;
    GolfLabels[5] = new Text(Main);
    GolfLabels[5].color = "#ffffff";
    GolfLabels[5].hAlign = "left";
    GolfLabels[5].hOffset = 65;
    GolfLabels[5].vOffset = 240;
    GolfLabels[5].size = 16;
    GolfLabelPar = GolfLabels[5];
    if (d) {
        GolfDeck = deckCopy(d);
    } else {
        GolfDeck = deckShuffle();
    }
    GolfThisScore = 0;
    golfUpdateScore();
    GolfRestartDeck = deckCopy(GolfDeck);
    for (var i = 0; i < GolfDeck.length; i++) {
        GolfDeck[i].img = new Image;
        GolfDeck[i].img.src = "Resources/back.png";
        GolfDeck[i].img.hOffset = 110;
        GolfDeck[i].img.vOffset = 200;
        GolfDeck[i].img.window = Main;
        GolfDeck[i].img.onMouseDown = "golfDoDeckClick()";
        GolfDeck[i].img.zOrder = 2 + i;
    }
    GolfBoard = [];
    for (var i = 0; i < 7; i++) {
        GolfBoard[i] = [];
        for (var j = 0; j < 5; j++) {
            var c = GolfDeck.pop();
            c.img.src = c.src;
            animateMove(c.img, 10 + 40 * i, 10 + 22 * j, 1);
            c.img.onMouseDown = "golfDoBoardClick("+i+")";
            c.img.zOrder = 2 + j;
            GolfBoard[i][j] = c;
        }
    }
    GolfStack = [];
    var c = GolfDeck.pop();
    c.img.src = c.src;
    animateMove(c.img, 160, 200, 1);
    c.img.onMouseDown = null;
    c.img.zOrder = 2 + GolfStack.length;
    GolfStack.push(c);
}

function golfAnyMoves()
{
    if (GolfDeck.length > 0) {
        return true;
    }
    var d = GolfStack[GolfStack.length-1];
    for (var i = 0; i < GolfBoard.length; i++) {
        if (GolfBoard[i].length > 0) {
            var c = GolfBoard[i][GolfBoard[i].length-1];
            if (d.rank != 13 && Math.abs(c.rank - d.rank) == 1) {
                return true;
            }
        }
    }
    return false;
}

function golfBoardEmpty()
{
    for (var i = 0; i < GolfBoard.length; i++) {
        if (GolfBoard[i].length > 0) {
            return false;
        }
    }
    return true;
}

function golfCheckEndGame()

{
    if (golfAnyMoves()) {
        return;
    }
    if (golfBoardEmpty()) {
        YouWon.visible = true;
        GolfThisScore = -GolfDeck.length;
    } else {
        GameOver.visible = true;
        GolfThisScore = 0;
        for (var i = 0; i < 7; i++) {
            GolfThisScore += GolfBoard[i].length;
        }
    }
    golfUpdateScore();
}

function golfDoDeckClick()
{
    Undo.push("golfDoDeckClick()");
    var c = GolfDeck.pop();
    c.img.src = c.src;
    animateMove(c.img, 160, 200, 1);
    c.img.onMouseDown = null;
    c.img.zOrder = 2 + GolfStack.length;
    GolfStack.push(c);
    golfCheckEndGame();
}

function golfDoBoardClick(i)
{
    Undo.push("golfDoBoardClick("+i+")");
    var c = GolfBoard[i][GolfBoard[i].length-1];
    var d = GolfStack[GolfStack.length-1];
    if (d.rank != 13 && Math.abs(c.rank - d.rank) == 1) {
        GolfBoard[i].pop();
        animateMove(c.img, 160, 200, 1);
        c.img.onMouseDown = null;
        c.img.zOrder = 2 + GolfStack.length;
        GolfStack.push(c);
        golfCheckEndGame();
    }
}

function golfGetName()
{
    return "Golf";
}

function golfDoNew()
{
    if (GolfBoard != null && !GameOver.visible && !YouWon.visible) {
        GolfThisScore = 0;
        for (var i = 0; i < 7; i++) {
            GolfThisScore += GolfBoard[i].length;
        }
    }
    if (GolfGames >= 9) {
        GolfScore = 0;
        GolfGames = 0;
    } else {
        GolfScore += GolfThisScore;
    }
    GolfGames++;
    golfNewBoard();
}

function golfDoRestart()
{
    if (GolfRestartDeck != null) {
        golfNewBoard(GolfRestartDeck);
    }
}

function golfDoHelp()
{
    var r = [];
    var d = GolfStack[GolfStack.length-1];
    for (var i = 0; i < GolfBoard.length; i++) {
        if (GolfBoard[i].length > 0) {
            var c = GolfBoard[i][GolfBoard[i].length-1];
            if (d.rank != 13 && Math.abs(c.rank - d.rank) == 1) {
                r.push([c.img.hOffset, c.img.vOffset]);
            }
        }
    }
    if (r.length > 0) {
        flash([r[random(0, r.length)]]);
    } else if (GolfDeck.length > 0) {
        flash([[110, 200]]);
    }
}

function golfInfo()
{
    return "Golf\n\n"+
        "Goal: Remove all the cards from the board.\n\n"+
        "Play: A card that is one rank higher or rank lower than the card on the top of the foundation may be moved down to the foundation. No card may be placed on a king. If there are no moves, move a card may be dealt from the deck.\n\n"+
        "Scoring: Your score at the end of the game is the number of cards left on the board. If no cards are left, your score is negative the number of cards left in the deck. Nine games (holes) constitute a full game with par 45.";
}
