var KlondikeCards;
var KlondikeRestartDeck;
var KlondikeSpots;
var KlondikeDeck;
var KlondikeStack;
var KlondikeFoundation;
var KlondikeBoardDown;
var KlondikeBoardUp;

function klondikeClearBoard()
{
    Selected = null;
    SelectedOverlay.visible = false;
    GameOver.visible = false;
    YouWon.visible = false;
    if (KlondikeSpots != null) {
        for (var i in KlondikeSpots) {
            KlondikeSpots[i].removeFromSuperview();
        }
    }
    if (KlondikeDeck != null) {
        for (var i in KlondikeDeck) {
            KlondikeDeck[i].img.removeFromSuperview();
        }
    }
    if (KlondikeStack != null) {
        for (var i in KlondikeStack) {
            KlondikeStack[i].img.removeFromSuperview();
        }
    }
    if (KlondikeFoundation != null) {
        for (var i in KlondikeFoundation) {
            for (var j in KlondikeFoundation[i]) {
                KlondikeFoundation[i][j].img.removeFromSuperview();
            }
        }
    }
    if (KlondikeBoardDown != null) {
        for (var i in KlondikeBoardDown) {
            for (var j in KlondikeBoardDown[i]) {
                KlondikeBoardDown[i][j].img.removeFromSuperview();
            }
        }
    }
    if (KlondikeBoardUp != null) {
        for (var i in KlondikeBoardUp) {
            for (var j in KlondikeBoardUp[i]) {
                KlondikeBoardUp[i][j].img.removeFromSuperview();
            }
        }
    }
    KlondikeRestartDeck = null;
    KlondikeSpots = null;
    KlondikeDeck = null;
    KlondikeStack = null;
    KlondikeFoundation = null;
    KlondikeBoardDown = null;
    KlondikeBoardUp = null;
}

function klondikeNewBoard(d)
{
    klondikeClearBoard();
    KlondikeSpots = [];
    var b = new Image;
    b.src = "Resources/selected.png";
    b.hOffset = 10;
    b.vOffset = 10;
    b.opacity = 128;
    b.window = Main;
    //b.onMouseDown = "klondikeDoDeckEmptyClick()";
    b.zOrder = 1;
    KlondikeSpots.push(b);
    for (var i = 0; i < 7; i++) {
        var b = new Image;
        b.src = "Resources/selected.png";
        b.hOffset = 10 + 40 * i;
        b.vOffset = 60;
        b.opacity = 128;
        b.window = Main;
        b.onMouseDown = "klondikeDoBoardEmptyClick("+i+")";
        b.zOrder = 1;
        KlondikeSpots.push(b);
    }
    for (var i = 0; i < 4; i++) {
        var b = new Image;
        b.src = "Resources/selected.png";
        b.hOffset = 120 + 40 * i;
        b.vOffset = 10;
        b.opacity = 128;
        b.window = Main;
        b.onMouseDown = "klondikeDoFoundationClick("+i+")";
        b.zOrder = 1;
        KlondikeSpots.push(b);
    }
    if (d) {
        KlondikeDeck = deckCopy(d);
    } else {
        KlondikeDeck = deckShuffle();
    }
    KlondikeRestartDeck = deckCopy(KlondikeDeck);
    KlondikeCards = [];
    for (var i = 0; i < KlondikeDeck.length; i++) {
        var c = KlondikeDeck[i];
        c.img = new Image;
        c.img.src = "Resources/back.png";
        c.img.hOffset = 10;
        c.img.vOffset = 10;
        c.img.window = Main;
        c.img.zOrder = 2 + i;
        c.img.onMouseDown = "klondikeDoClickDeck()";
        c.ki = KlondikeCards.length;
        KlondikeCards.push(c);
    }
    KlondikeStack = [];
    KlondikeFoundation = [Array(), Array(), Array(), Array()];
    KlondikeBoardDown = [Array(), Array(), Array(), Array(), Array(), Array(), Array()];
    KlondikeBoardUp = [Array(), Array(), Array(), Array(), Array(), Array(), Array()];
    for (var i = 0; i < 7; i++) {
        var c = KlondikeDeck.pop();
        c.col = i;
        animateMove(c.img, 10 + 40 * i, 60 + 5 * KlondikeBoardDown[i].length + 13 * KlondikeBoardUp[i].length, 1);
        c.img.onMouseDown = "klondikeDoClickBoardUp("+i+")";
        c.img.zOrder = 2 + KlondikeBoardDown[i].length + KlondikeBoardUp[i].length;
        c.img.src = c.src;
        var mi = new MenuItem;
        mi.title = "Show card ("+RankStr[c.rank]+SuitStr[c.suit]+")";
        mi.onSelect = "show(KlondikeCards["+c.ki+"].img)";
        c.img.contextMenuItems = [mi];
        KlondikeBoardUp[i].push(c);
        for (var j = i+1; j < 7; j++) {
            var c = KlondikeDeck.pop();
            c.col = j;
            animateMove(c.img, 10 + 40 * j, 60 + 5 * KlondikeBoardDown[i].length + 13 * KlondikeBoardUp[j].length, 1);
            c.img.zOrder = 2 + KlondikeBoardDown[i].length + KlondikeBoardUp[j].length;
            c.img.onMouseDown = "klondikeDoClickBoardDown("+j+")";
            KlondikeBoardDown[j].push(c);
        }
    }
}

function klondikeCheckWin()
{
    for (var i = 0; i < 4; i++) {
        if (KlondikeFoundation[i].length < 13) {
            return false;
        }
    }
    return true;
}

function klondikeCheckLose()
{
    if (KlondikeDeck.length > 0) {
        return false;
    }
    if (klondikeGetMoves().length > 0) {
        return false;
    }
    return true;
}

function klondikeCheckEndGame()
{
    if (klondikeCheckWin()) {
        YouWon.visible = true;
    } else if (klondikeCheckLose()) {
        GameOver.visible = true;
    }
}

function klondikeDoDeckEmptyClick()
{
    Undo.push("klondikeDoDeckEmptyClick()");
    while (KlondikeStack.length > 0) {
        var c = KlondikeStack.pop();
        c.img.src = "Resources/back.png";
        c.img.hOffset = 10;
        c.img.vOffset = 10;
        c.img.onMouseDown = "klondikeDoClickDeck()";
        c.img.zOrder = 2 + KlondikeDeck.length;
        c.img.contextMenuItems = [];
        KlondikeDeck.push(c);
    }
}

function klondikeDoClickDeck()
{
    Undo.push("klondikeDoClickDeck()");
    var c = KlondikeDeck.pop();
    c.img.src = c.src;
    animateMove(c.img, 50, 10, 1);
    c.img.onMouseDown = "klondikeDoClickStack()";
    c.img.zOrder = 1 + KlondikeStack.length;
    var mi = new MenuItem;
    mi.title = "Show card ("+RankStr[c.rank]+SuitStr[c.suit]+")";
    mi.onSelect = "show(KlondikeCards["+c.ki+"].img)";
    c.img.contextMenuItems = [mi];
    KlondikeStack.push(c);
    klondikeCheckEndGame();
}

function klondikeDoClickStack()
{
    Undo.push("klondikeDoClickStack()");
    var c = KlondikeStack[KlondikeStack.length-1];
    if (Selected == null) {
        Undo[Undo.length-1] += " //select";
        c.col = -1;
        Selected = c;
        SelectedOverlay.hOffset = c.img.hOffset;
        SelectedOverlay.vOffset = c.img.vOffset;
        SelectedOverlay.visible = true;
    } else if (Selected == c) {
        for (var j = 0; j < KlondikeFoundation.length; j++) {
            if ((c.rank == 1 && KlondikeFoundation[j].length == 0) || (KlondikeFoundation[j].length > 0 && c.suit == KlondikeFoundation[j][KlondikeFoundation[j].length-1].suit && c.rank == KlondikeFoundation[j][KlondikeFoundation[j].length-1].rank+1)) {
                Selected = null;
                SelectedOverlay.visible = false;
                c = KlondikeStack.pop();
                c.img.onMouseDown = null;
                animateMove(c.img, 120 + 40 * j, 10, 1);
                c.img.zOrder = 1 + KlondikeFoundation[j].length;
                KlondikeFoundation[j].push(c);
                klondikeCheckEndGame();
                break;
            }
        }
        Selected = null;
        SelectedOverlay.visible = false;
    } else {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    }
}

function klondikeDoFoundationClick(i)
{
    Undo.push("klondikeDoFoundationClick("+i+")");
    if (Selected != null) {
        if ((Selected.rank == 1 && KlondikeFoundation[i].length == 0) || (KlondikeFoundation[i].length > 0 && Selected.suit == KlondikeFoundation[i][KlondikeFoundation[i].length-1].suit && Selected.rank == KlondikeFoundation[i][KlondikeFoundation[i].length-1].rank+1)) {
            SelectedOverlay.visible = false;
            var c = (Selected.col >= 0) ? KlondikeBoardUp[Selected.col].pop() : KlondikeStack.pop();
            animateMove(c.img, 120 + 40 * i, 10, 1);
            c.img.onMouseDown = null;
            c.img.zOrder = 1 + KlondikeFoundation[i].length;
            KlondikeFoundation[i].push(c);
            klondikeCheckEndGame();
            Selected = null;
        } else {
            Undo[Undo.length-1] += " //select";
            Selected = null;
            SelectedOverlay.visible = false;
        }
    }
}

function klondikeDoBoardEmptyClick(i)
{
    Undo.push("klondikeDoBoardEmptyClick("+i+")");
    if (Selected != null) {
        if (Selected.rank == 13) {
            var c = Selected.col >= 0 ? KlondikeBoardUp[Selected.col].pop() : KlondikeStack.pop();
            Selected = null;
            SelectedOverlay.visible = false;
            c.col = i;
            animateMove(c.img, 10 + 40 * i, 60, 1);
            c.img.zOrder = 2;
            c.img.onMouseDown = "klondikeDoClickBoardUp("+i+")";
            KlondikeBoardUp[i].push(c);
            klondikeCheckEndGame();
        } else if (Selected.col >= 0) {
            var newcol = i;
            var a = KlondikeBoardUp[Selected.col];
            var i = a.length-1;
            while (i >= 0 && a[i].rank != 13) {
                i--;
                if (i >= 0 && (a[i].rank != a[i+1].rank-1 && a[i].color == a[i+1].color)) {
                    i = -1;
                    break;
                }
            }
            if (i >= 0) {
                Selected = null;
                SelectedOverlay.visible = false;
                for (var j = i; j < a.length; j++) {
                    var d = a[j];
                    d.col = newcol;
                    d.img.hOffset = 10 + 40 * newcol;
                    d.img.vOffset = 60 + 5 * KlondikeBoardDown[newcol].length + 13 * KlondikeBoardUp[newcol].length;
                    d.img.zOrder = 2 + KlondikeBoardDown[newcol].length + KlondikeBoardUp[newcol].length;
                    d.img.onMouseDown = "klondikeDoClickBoardUp("+newcol+")";
                    KlondikeBoardUp[newcol].push(d);
                }
                a.splice(i, a.length-i);
                klondikeCheckEndGame();
            } else {
                Undo[Undo.length-1] += " //select";
                Selected = null;
                SelectedOverlay.visible = false;
            }
        } else {
            Undo[Undo.length-1] += " //select";
            Selected = null;
            SelectedOverlay.visible = false;
        }
    }
}

function klondikeDoClickBoardDown(i)
{
    Undo.push("klondikeDoClickBoardDown("+i+")");
    if (Selected == null && KlondikeBoardUp[i].length == 0) {
        var c = KlondikeBoardDown[i].pop();
        c.img.src = c.src;
        c.img.onMouseDown = "klondikeDoClickBoardUp("+i+")";
        var mi = new MenuItem;
        mi.title = "Show card ("+RankStr[c.rank]+SuitStr[c.suit]+")";
        mi.onSelect = "show(KlondikeCards["+c.ki+"].img)";
        c.img.contextMenuItems = [mi];
        KlondikeBoardUp[i].push(c);
        klondikeCheckEndGame();
    } else {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    }
}

function klondikeDoClickBoardUp(i)
{
    Undo.push("klondikeDoClickBoardUp("+i+")");
    var c = KlondikeBoardUp[i][KlondikeBoardUp[i].length-1];
    if (Selected == null) {
        Undo[Undo.length-1] += " //select";
        Selected = c;
        SelectedOverlay.hOffset = c.img.hOffset;
        SelectedOverlay.vOffset = c.img.vOffset;
        SelectedOverlay.visible = true;
    } else if (c == Selected) {
        for (var j = 0; j < KlondikeFoundation.length; j++) {
            if ((c.rank == 1 && KlondikeFoundation[j].length == 0) || (KlondikeFoundation[j].length > 0 && c.suit == KlondikeFoundation[j][KlondikeFoundation[j].length-1].suit && c.rank == KlondikeFoundation[j][KlondikeFoundation[j].length-1].rank+1)) {
                Selected = null;
                SelectedOverlay.visible = false;
                c = KlondikeBoardUp[i].pop();
                animateMove(c.img, 120 + 40 * j, 10, 1);
                c.img.onMouseDown = null;
                c.img.zOrder = 1 + KlondikeFoundation[j].length;
                KlondikeFoundation[j].push(c);
                klondikeCheckEndGame();
                break;
            }
        }
        Selected = null;
        SelectedOverlay.visible = false;
    } else if (Selected.col >= 0) {
        var a = KlondikeBoardUp[Selected.col];
        var i = a.length-1;
        while (i >= 0 && (a[i].rank != c.rank-1 || a[i].color == c.color)) {
            i--;
            if (i >= 0 && (a[i].rank != a[i+1].rank-1 && a[i].color == a[i+1].color)) {
                i = -1;
                break;
            }
        }
        if (i >= 0) {
            Selected = null;
            SelectedOverlay.visible = false;
            for (var j = i; j < a.length; j++) {
                var d = a[j];
                d.col = c.col;
                d.img.hOffset = 10 + 40 * c.col;
                d.img.vOffset = 60 + 5 * KlondikeBoardDown[c.col].length + 13 * KlondikeBoardUp[c.col].length;
                d.img.zOrder = 2 + KlondikeBoardDown[c.col].length + KlondikeBoardUp[c.col].length;
                d.img.onMouseDown = "klondikeDoClickBoardUp("+c.col+")";
                KlondikeBoardUp[c.col].push(d);
            }
            a.splice(i, a.length-i);
            klondikeCheckEndGame();
        } else {
            Undo[Undo.length-1] += " //select";
            Selected = null;
            SelectedOverlay.visible = false;
        }
    } else if (Selected.rank == c.rank-1 && Selected.color != c.color) {
        Selected = null;
        SelectedOverlay.visible = false;
        c = KlondikeStack.pop();
        c.col = i;
        animateMove(c.img, 10 + 40 * i, 60 + 5 * KlondikeBoardDown[i].length + 13 * KlondikeBoardUp[i].length, 1);
        c.img.onMouseDown = "klondikeDoClickBoardUp("+i+")";
        c.img.zOrder = 2 + KlondikeBoardDown[i].length + KlondikeBoardUp[i].length;
        KlondikeBoardUp[i].push(c);
        klondikeCheckEndGame();
    } else {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    }
}

function klondikeGetName()
{
    return "Klondike";
}

function klondikeDoNew()
{
    klondikeNewBoard();
}

function klondikeDoRestart()
{
    if (KlondikeRestartDeck != null) {
        klondikeNewBoard(KlondikeRestartDeck);
    }
}

function klondikeGetMoves()
{
    var pairs = [];
    for (var i = 0; i < 7; i++) {
        if (KlondikeBoardUp[i].length == 0 && KlondikeBoardDown[i].length > 0) {
            pairs.push([KlondikeBoardDown[i][KlondikeBoardDown[i].length-1]]);
        }
    }
    if (pairs.length == 0) {
        for (var i = 0; i < 7; i++) {
            if (KlondikeBoardUp[i].length > 0) {
                var c = KlondikeBoardUp[i][KlondikeBoardUp[i].length-1];
                for (var j = 0; j < 7; j++) {
                    if (i != j && KlondikeBoardUp[j].length > 0) {
                        if (c.rank == KlondikeBoardUp[j][0].rank+1 && c.color != KlondikeBoardUp[j][0].color) {
                            pairs.push([c, KlondikeBoardUp[j][KlondikeBoardUp[j].length-1]]);
                            break;
                        }
                    }
                }
                if (KlondikeStack.length > 0 && c.rank == KlondikeStack[KlondikeStack.length-1].rank+1 && c.color != KlondikeStack[KlondikeStack.length-1].color) {
                    pairs.push([c, KlondikeStack[KlondikeStack.length-1]]);
                }
            } else if (KlondikeBoardDown[i].length == 0) {
                for (var j = 0; j < 7; j++) {
                    if (KlondikeBoardUp[j].length > 0 && KlondikeBoardUp[j][0].rank == 13 && KlondikeBoardDown[j].length > 0) {
                        pairs.push([KlondikeBoardUp[j][KlondikeBoardUp[j].length-1]]);
                    }
                }
                if (KlondikeStack.length > 0 && KlondikeStack[KlondikeStack.length-1].rank == 13) {
                    pairs.push([KlondikeStack[KlondikeStack.length-1]]);
                }
            }
        }
    }
    if (pairs.length == 0) {
        var t = [];
        for (var i = 0; i < 7; i++) {
            if (KlondikeBoardUp[i].length > 0) {
                t.push(KlondikeBoardUp[i][KlondikeBoardUp[i].length-1]);
            }
        }
        if (KlondikeStack.length > 0) {
            t.push(KlondikeStack[KlondikeStack.length-1]);
        }
        for (var i = 0; i < t.length; i++) {
            var c = t[i];
            for (var j = 0; j < 4; j++) {
                if (c.rank == 1 && KlondikeFoundation[j].length == 0) {
                    pairs.push([c]);
                } else if (c.rank == KlondikeFoundation[j].length+1 && c.suit == KlondikeFoundation[j][0].suit) {
                    pairs.push([c, KlondikeFoundation[j][KlondikeFoundation[j].length-1]]);
                }
            }
        }
    }
    if (pairs.length == 0) {
        for (var i = 0; i < 7; i++) {
            if (KlondikeBoardUp[i].length > 0) {
                var c = KlondikeBoardUp[i][KlondikeBoardUp[i].length-1];
                for (var j = 0; j < 7; j++) {
                    if (i != j && KlondikeBoardUp[j].length > 0) {
                        for (var k = 1; k < KlondikeBoardUp[j].length; k++) {
                            if (c.rank == KlondikeBoardUp[j][k].rank+1 && c.color != KlondikeBoardUp[j][k].color) {
                                var d = KlondikeBoardUp[j][k-1];
                                for (var f = 0; f < 4; f++) {
                                    if (d.rank == KlondikeFoundation[f].length+1 && d.suit == KlondikeFoundation[f][0].suit) {
                                        pairs.push([c, KlondikeBoardUp[j][KlondikeBoardUp[j].length-1]]);
                                        break;
                                    }
                                }
                                break;
                            }
                        }
                    }
                }
            }
        }
    }
    if (pairs.length == 0) {
        if (KlondikeDeck.length > 0) {
            pairs.push([KlondikeDeck[KlondikeDeck.length-1]]);
        }
    }
    return pairs;
}

function klondikeDoHelp()
{
    var pairs = klondikeGetMoves();
    if (pairs.length > 0) {
        var p = pairs[random(0, pairs.length)];
        var a = [];
        for (var i = 0; i < p.length; i++) {
            a.push([p[i].img.hOffset, p[i].img.vOffset]);
        }
        flash(a);
    }
}

function klondikeInfo()
{
    return "Klondike\n\n"+
        "Goal: Move all cards to the foundation (top right).\n\n"+
        "Play: Cards may be placed on top of another card of one higher rank and opposite colour. Kings may be placed on an empty spot on the board. Cards may be moved to the foundation in rank order, aces first, matching suit. New cards may be dealt from the deck one at a time.";
}
