var MontecarloRestartDeck;
var MontecarloBoard;
var MontecarloDeck;

function montecarloClearBoard()
{
    Selected = null;
    SelectedOverlay.visible = false;
    GameOver.visible = false;
    YouWon.visible = false;
    if (MontecarloBoard != null) {
        for (var i = 0; i < MontecarloBoard.length; i++) {
            for (var j = 0; j < MontecarloBoard[i].length; j++) {
                if (MontecarloBoard[i][j] != null) {
                    MontecarloBoard[i][j].img.removeFromSuperview();
                }
            }
        }
    }
    if (MontecarloDeck != null) {
        for (var i = 0; i < MontecarloDeck.length; i++) {
            MontecarloDeck[i].img.removeFromSuperview();
        }
    }
    MontecarloRestartDeck = null;
    MontecarloBoard = null;
    MontecarloDeck = null;
}

function montecarloNewBoard(d)
{
    montecarloClearBoard();
    MontecarloBoard = [Array(5), Array(5), Array(5), Array(5), Array(5)];
    if (d) {
        MontecarloDeck = deckCopy(d);
    } else {
        MontecarloDeck = deckShuffle();
    }
    MontecarloRestartDeck = deckCopy(MontecarloDeck);
    for (var i = 0; i < MontecarloDeck.length; i++) {
        var c = MontecarloDeck[i];
        c.img = new Image;
        c.img.src = "Resources/back.png";
        c.img.hOffset = 200;
        c.img.vOffset = 220;
        c.img.window = Main;
        c.img.zOrder = 2 + i;
    }
    for (var i = 0; i < MontecarloBoard.length; i++) {
        for (var j = 0; j < MontecarloBoard[i].length; j++) {
            var c = MontecarloDeck.pop();
            c.img.src = c.src;
            c.row = i;
            c.col = j;
            animateMove(c.img, 10 + 36 * j, 10 + 50 * i, 1);
            c.img.onMouseDown = "montecarloDoClick("+i+","+j+")";
            MontecarloBoard[i][j] = c;
        }
    }
    if (!montecarloAnyMoves()) {
        montecarloNewBoard();
    }
}

function montecarloDoClick(i, j)
{
    Undo.push("montecarloDoClick("+i+","+j+")");
    var c = MontecarloBoard[i][j];
    if (Selected == null) {
        Undo[Undo.length-1] += " //select";
        Selected = c;
        SelectedOverlay.hOffset = c.img.hOffset;
        SelectedOverlay.vOffset = c.img.vOffset;
        SelectedOverlay.visible = true;
    } else if (Selected == c) {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    } else if (Selected.rank == c.rank && Math.abs(Selected.row - c.row) <= 1 && Math.abs(Selected.col - c.col) <= 1) {
        Selected.img.visible = false;
        c.img.visible = false;
        Selected = null;
        SelectedOverlay.visible = null;
        for (var i = 0; i < MontecarloBoard.length; i++) {
            for (var j = 0, p = 0; j < MontecarloBoard[i].length; j++, p++) {
                while (p < MontecarloBoard[i].length && (MontecarloBoard[i][p] == null || !MontecarloBoard[i][p].img.visible)) {
                    p++;
                }
                if (p < MontecarloBoard[i].length) {
                    if (j < p) {
                        var c = MontecarloBoard[i][p];
                        animateMove(c.img, 10 + 36 * j, 10 + 50 * i, 1);
                        c.img.onMouseDown = "montecarloDoClick("+i+","+j+")";
                        c.col = j;
                        MontecarloBoard[i][j] = c;
                        MontecarloBoard[i][p] = null;
                    }
                } else {
                    MontecarloBoard[i][j] = null;
                }
            }
        }
        for (var j = 0; j < MontecarloBoard[0].length; j++) {
            for (var i = 0, p = 0; i < MontecarloBoard.length; i++, p++) {
                while (p < MontecarloBoard.length && (MontecarloBoard[p][j] == null || !MontecarloBoard[p][j].img.visible)) {
                    p++;
                }
                if (p < MontecarloBoard.length) {
                    if (i < p) {
                        var c = MontecarloBoard[p][j];
                        animateMove(c.img, 10 + 36 * j, 10 + 50 * i, 1);
                        c.img.onMouseDown = "montecarloDoClick("+i+","+j+")";
                        c.row = i;
                        MontecarloBoard[i][j] = c;
                        MontecarloBoard[p][j] = null;
                    }
                } else {
                    MontecarloBoard[i][j] = null;
                }
            }
        }
        for (var i = 0; i < MontecarloBoard.length; i++) {
            for (var j = 0; j < MontecarloBoard[i].length; j++) {
                if (MontecarloBoard[i][j] == null) {
                    if (MontecarloDeck.length > 0) {
                        var c = MontecarloDeck.pop();
                        c.img.src = c.src;
                        animateMove(c.img, 10 + 36 * j, 10 + 50 * i, 1);
                        c.img.onMouseDown = "montecarloDoClick("+i+","+j+")";
                        c.row = i;
                        c.col = j;
                        MontecarloBoard[i][j] = c;
                    }
                }
            }
        }
        if (MontecarloBoard[0][0] == null) {
            YouWon.visible = true;
        } else {
            if (!montecarloAnyMoves()) {
                GameOver.visible = true;
            }
        }
    } else {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    }
}

function montecarloListMoves()
{
    var r = [];
    for (var i = 0; i < MontecarloBoard.length; i++) {
        for (var j = 0; j < MontecarloBoard[i].length; j++) {
            var c = MontecarloBoard[i][j];
            if (c != null) {
                if (j+1 < MontecarloBoard[i].length
                 && MontecarloBoard[i][j+1] != null
                 && c.rank == MontecarloBoard[i][j+1].rank) {
                    r.push([[i, j], [i, j+1]]);
                }
                if (i+1 < MontecarloBoard.length
                 && j < MontecarloBoard[i+1].length
                 && MontecarloBoard[i+1][j] != null
                 && c.rank == MontecarloBoard[i+1][j].rank) {
                    r.push([[i, j], [i+1, j]]);
                }
                if (i+1 < MontecarloBoard.length
                 && j+1 < MontecarloBoard[i+1].length
                 && MontecarloBoard[i+1][j+1] != null
                 && c.rank == MontecarloBoard[i+1][j+1].rank) {
                    r.push([[i, j], [i+1, j+1]]);
                }
                if (i > 0
                 && j+1 < MontecarloBoard[i-1].length
                 && MontecarloBoard[i-1][j+1] != null
                 && c.rank == MontecarloBoard[i-1][j+1].rank) {
                    r.push([[i, j], [i-1, j+1]]);
                }
            }
        }
    }
    return r;
}

function montecarloAnyMoves()
{
    return montecarloListMoves().length > 0;
}

function montecarloGetName()
{
    return "Monte Carlo";
}

function montecarloDoNew()
{
    montecarloNewBoard();
}

function montecarloDoRestart()
{
    if (MontecarloRestartDeck != null) {
        montecarloNewBoard(MontecarloRestartDeck);
    }
}

function montecarloDoHelp()
{
    var pairs = montecarloListMoves();
    if (pairs.length > 0) {
        var p = pairs[random(0, pairs.length)];
        flash([[10 + 36 * p[0][1], 10 + 50 * p[0][0]], [10 + 36 * p[1][1], 10 + 50 * p[1][0]]]);
    }
}

function montecarloInfo()
{
    return "Monte Carlo\n\n"+
        "Goal: Remove all the cards from the board.\n\n"+
        "Play: Select pairs of cards of equal rank which are adjacent to one another (horizontally, vertically, or diagonally). Cards are shifted to the left, then upwards, then from the deck, to fill empty spaces.";
}
