var PyramidRestartDeck;
var PyramidDeck;
var PyramidBoard;
var PyramidStack;

function pyramidClearBoard(b)
{
    Selected = null;
    SelectedOverlay.visible = false;
    GameOver.visible = false;
    YouWon.visible = false;
    if (PyramidDeck != null) {
        for (var i in PyramidDeck) {
            PyramidDeck[i].img.removeFromSuperview();
        }
    }
    if (PyramidBoard != null) {
        for (var i = 0; i < 7; i++) {
            for (var j = 0; j <= i; j++) {
                if (PyramidBoard[i][j].img) {
                    PyramidBoard[i][j].img.removeFromSuperview();
                }
            }
        }
    }
    if (PyramidStack != null) {
        for (var i in PyramidStack) {
            PyramidStack[i].img.removeFromSuperview();
        }
    }
    PyramidRestartDeck = null;
    PyramidDeck = null;
    PyramidBoard = null;
    PyramidStack = null;
}

function pyramidNewBoard(b, d)
{
    pyramidClearBoard();
    if (d) {
        PyramidDeck = deckCopy(d);
    } else {
        PyramidDeck = deckShuffle();
    }
    PyramidRestartDeck = deckCopy(PyramidDeck);
    for (var i = 0; i < PyramidDeck.length; i++) {
        PyramidDeck[i].img = new Image;
        PyramidDeck[i].img.src = PyramidDeck[i].src;
        PyramidDeck[i].img.hOffset = 10;
        PyramidDeck[i].img.vOffset = 10;
        PyramidDeck[i].img.window = Main;
        PyramidDeck[i].img.onMouseDown = "pyramidDoDeckClick()";
        PyramidDeck[i].img.zOrder = PyramidDeck.length;
    }
    PyramidBoard = [];
    for (var i = 0; i < 7; i++) {
        PyramidBoard[i] = [];
        for (var j = 0; j <= i; j++) {
            PyramidBoard[i][j] = new Object;
        }
    }
    PyramidStack = [];
    for (var i = 0; i < 7; i++) {
        for (var j = 0; j <= i; j++) {
            var c = PyramidDeck.pop();
            animateMove(c.img, 150 - i*20 + j*40, 10 + i*30, 1);
            c.img.onMouseDown = "pyramidDoBoardClick("+i+","+j+")";
            c.img.zOrder = 1 + i;
            PyramidBoard[i][j] = c;
        }
    }
    Selected = null;
    SelectedOverlay.visible = false;
}

function pyramidAnyMoves()
{
    var seen = Array(14);
    if (PyramidStack.length > 0) {
        seen[PyramidStack[PyramidStack.length-1].rank] = 1;
    }
    for (var i = 0; i < 7; i++) {
        for (var j = 0; j <= i; j++) {
            if (PyramidBoard[i][j].img.visible) {
                if (i == PyramidBoard.length-1 || (!PyramidBoard[i+1][j].img.visible && !PyramidBoard[i+1][j+1].img.visible)) {
                    if (seen[13-PyramidBoard[i][j].rank]) {
                        return true;
                    }
                    seen[PyramidBoard[i][j].rank] = 1;
                }
            }
        }
    }
    return seen[13];
}

function pyramidDoClick(c)
{
    if (Selected == null) {
        if (c.rank == 13) {
            c.img.visible = false;
            if (c.removed) {
                eval(c.removed);
            }
        } else {
            Undo[Undo.length-1] += " //select";
            Selected = c;
            SelectedOverlay.hOffset = c.img.hOffset;
            SelectedOverlay.vOffset = c.img.vOffset;
            SelectedOverlay.visible = true;
        }
    } else if (Selected == c) {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    } else if (Selected.rank + c.rank == 13) {
        c.img.visible = false;
        Selected.img.visible = false;
        if (c.removed) {
            eval(c.removed);
        }
        if (Selected.removed) {
            eval(Selected.removed);
        }
        Selected = null;
        SelectedOverlay.visible = false;
    } else {
        Undo[Undo.length-1] += " //select";
        Selected = null;
        SelectedOverlay.visible = false;
    }
    if (!PyramidBoard[0][0].img.visible) {
        YouWon.visible = true;
    } else if (PyramidDeck.length == 0) {
        if (!pyramidAnyMoves()) {
            GameOver.visible = true;
        }
    }
}

function pyramidDoRemoved(c)
{
    c.img.removeFromSuperview();
}

function pyramidDoDeckClick()
{
    Undo.push("pyramidDoDeckClick()");
    if (Selected != null && Selected == PyramidDeck[PyramidDeck.length-1]) {
        SelectedOverlay.visible = false;
        var c = PyramidDeck.pop();
        animateMove(c.img, 50, 10, 2);
        c.img.onMouseDown = "pyramidDoStackClick()";
        c.img.zOrder = 1+PyramidStack.length;
        PyramidStack.push(c);
        Selected = null;
        if (PyramidDeck.length == 0) {
            if (!pyramidAnyMoves()) {
                GameOver.visible = true;
            }
        }
        return;
    }
    var c = PyramidDeck[PyramidDeck.length-1];
    c.removed = "pyramidDoRemoved(PyramidDeck.pop())";
    pyramidDoClick(c);
}

function pyramidDoStackClick()
{
    Undo.push("pyramidDoStackClick()");
    var c = PyramidStack[PyramidStack.length-1];
    c.removed = "pyramidDoRemoved(PyramidStack.pop())";
    pyramidDoClick(c);
}

function pyramidDoBoardClick(i, j)
{
    Undo.push("pyramidDoBoardClick("+i+","+j+")");
    if (i == PyramidBoard.length-1 || (!PyramidBoard[i+1][j].img.visible && !PyramidBoard[i+1][j+1].img.visible)) {
        pyramidDoClick(PyramidBoard[i][j]);
    }
}

function pyramidGetName()
{
    return "Pyramid";
}

function pyramidDoNew()
{
    pyramidNewBoard(PyramidBoard);
    Selected = null;
    SelectedOverlay.visible = false;
}

function pyramidDoRestart()
{
    if (PyramidRestartDeck != null) {
        pyramidNewBoard(PyramidBoard, PyramidRestartDeck);
    }
}

function pyramidDoHelp()
{
    var available = [];
    if (PyramidDeck.length > 0) {
        available.push(PyramidDeck[PyramidDeck.length-1]);
    }
    if (PyramidStack.length > 0) {
        available.push(PyramidStack[PyramidStack.length-1]);
    }
    for (var i = 0; i < 7; i++) {
        for (var j = 0; j <= i; j++) {
            if (PyramidBoard[i][j].img.visible) {
                if (i == PyramidBoard.length-1 || (!PyramidBoard[i+1][j].img.visible && !PyramidBoard[i+1][j+1].img.visible)) {
                    available.push(PyramidBoard[i][j]);
                }
            }
        }
    }
    var pairs = [];
    for (var i = 0; i < available.length; i++) {
        if (available[i].rank == 13) {
            pairs.push([available[i]]);
        } else {
            for (var j = i+1; j < available.length; j++) {
                if (available[i].rank + available[j].rank == 13) {
                    pairs.push([available[i], available[j]]);
                }
            }
        }
    }
    if (pairs.length > 0) {
        var p = pairs[random(0, pairs.length)];
        var a = [];
        for (var i = 0; i < p.length; i++) {
            a.push([p[i].img.hOffset, p[i].img.vOffset]);
        }
        flash(a);
    } else if (PyramidDeck.length > 0) {
        flash([[10, 10]]);
    }
}

function pyramidInfo()
{
    return "Pyramid\n\n"+
        "Goal: Remove all the cards from the pyramid.\n\n"+
        "Play: Select pairs of cards whose rank sum to 13 (Ace = 1, Jack = 11, Queen = 12). Kings are valued 13 and can be removed without pairing. New cards can be drawn from the deck when there are no matches.";
}
