var Rank = "A23456789TJQK";
var Suit = "CHSD";
var RankStr = [null,"A","2","3","4","5","6","7","8","9","10","J","Q","K"];
var SuitStr = ["\u2663", "\u2665", "\u2660", "\u2666"];
var CurrentGame;
var Selected;
var Undo;
var Animate = true;

function deckShuffle()
{
    deck = [];
    for (var r = 0; r < Rank.length; r++) {
        for (var s = 0; s < Suit.length; s++) {
            var c = new Object;
            c.rank = r + 1;
            c.suit = s;
            c.color = s & 1;
            c.src = "Resources/"+Rank[r]+Suit[s]+".png";
            deck.push(c);
        }
    }
    for (var i = 0; i < deck.length; i++) {
        var j = random(i, deck.length);
        var x = deck[j];
        deck[j] = deck[i];
        deck[i] = x;
    }
    return deck;
}

function deckCopy(d)
{
    var r = [];
    for (var i in d) {
        var x = new Object;
        x.rank = d[i].rank;
        x.suit = d[i].suit;
        x.color = d[i].color;
        x.src = d[i].src;
        r.push(x);
    }
    return r;
}

function doAnimate()
{
    return preferences.Animate.value != 0 && Animate;
}

function animateMove(img, x, y, t)
{
    var z = img.zOrder;
    img.zOrder = 999;
    if (preferences.Animate.value != 0 && Animate) {
        img.moveTo(x, y, t);
    } else {
        img.hOffset = x;
        img.vOffset = y;
    }
    img.zOrder = z;
}

function flash(p)
{
    var overlay = [];
    for (var i = 0; i < p.length; i++) {
        var o = new Image;
        o.src = "Resources/selected.png";
        o.hOffset = p[i][0];
        o.vOffset = p[i][1];
        o.opacity = 128;
        o.window = Main;
        o.zOrder = 999;
        overlay.push(o);
    }
    for (var i = 0; i < 3; i++) {
        for (var j = 0; j < overlay.length; j++) {
            overlay[j].visible = true;
        }
        sleep(200);
        for (var j = 0; j < overlay.length; j++) {
            overlay[j].visible = false;
        }
        sleep(200);
    }
    for (var i = 0; i < overlay.length; i++) {
        overlay[i].removeFromSuperview();
    }
}

function show(img)
{
    var z = img.zOrder;
    img.zOrder = 999;
    updateNow();
    sleep(1000);
    img.zOrder = z;
    updateNow();
}

include("freecell.js");
include("golf.js");
include("klondike.js");
include("montecarlo.js");
include("pyramid.js");

function doNew()
{
    StartInfo.visible = false;
    if (CurrentGame != null && !GameOver.visible && !YouWon.visible && alert(eval(CurrentGame+"GetName()")+": Begin new game?", "Yes", "No") != 1) {
        return;
    }
    CurrentGame = preferences.Game.value;
    Undo = [];
    eval(CurrentGame+"DoNew()");
}

function doRestart()
{
    if (CurrentGame == null) {
        return;
    }
    if (CurrentGame != null && !GameOver.visible && !YouWon.visible && alert(eval(CurrentGame+"GetName()")+": Restart same game?", "Yes", "No") != 1) {
        return;
    }
    var a = Animate;
    Animate = false;
    eval(CurrentGame+"DoRestart()");
    Undo = [];
    Animate = a;
}

function doUndo()
{
    if (CurrentGame == null) {
        return;
    }
    var a = Animate;
    Animate = false;
    eval(CurrentGame+"DoRestart()");
    do {
        Undo.pop();
    } while (Undo.length > 0 && /\/\/select/.test(Undo[Undo.length-1]));
    var u = Undo;
    Undo = [];
    for (var i in u) {
        eval(u[i]);
    }
    Undo = u;
    Animate = a;
}

function doHelp()
{
    if (CurrentGame == null) {
        return;
    }
    eval(CurrentGame+"DoHelp()");
}

function doInfo()
{
    Info.visible = !Info.visible;
}

function onPreferencesChanged()
{
    if (preferences.Game.value != CurrentGame) {
        if (CurrentGame != null) {
            eval(CurrentGame+"ClearBoard()");
            CurrentGame = null;
        }
        Name.data = eval(preferences.Game.value+"GetName()");
        Info.data = eval(preferences.Game.value+"Info()");
        doNew();
    }
}

Name.data = eval(preferences.Game.value+"GetName()");
Info.data = eval(preferences.Game.value+"Info()");
